'
' Message box, Input box, Menu and Button for QB 4.5 with DirectQB
' Version 1.1
'
' Usage: see MsgBox, Menu functions and Button sub
' Note: only Button supports layers. All other use VIDEO layer.
'
' Press F5 for demonstration.
'
' Important: MsgBox, InputBox, Menu and Button use fixed 6x6 font (stored in
' program file with FNT2BAS).
'
' What's new:
'    - bugfix in Menu: if clickout% was disabled and somebody dragged mouse
'      out of menu, it was closed
'    - selectable colors (scroll down to see)
'
' Use freely in your programs, just give me a credit.
'
'                              Jernej Simoncic, jernej.simoncic@guest.arnes.si
'
'
'
'
DEFINT A-Z
'$INCLUDE: 'directqb.bi'
DECLARE SUB Button (lay%, bx%, by%, bwidth%, bheight%, txt$, press%)
DECLARE SUB InputBox (inptext$, txt$, btn$, tit$, pbutton%, resbk%)
DECLARE FUNCTION Menu (x%, y%, Items AS STRING, clickouts%, restbck%)
DECLARE FUNCTION MsgBox (txt$, btn$, tit$, resbk%)

DIM Font AS STRING * 2305
RESTORE Font
FOR i% = 0 TO 47
     READ t$
     Result$ = ""
     FOR j% = 0 TO (LEN(t$)) \ 4 - 1
       Bytes4$ = MID$(t$, j% * 4 + 1, 4)
       b& = 0
       FOR t% = 4 TO 1 STEP -1
          b& = b& * 64 + ASC(MID$(Bytes4$, t%)) - 48
       NEXT
       FOR t% = 1 TO 3
          Result$ = Result$ + CHR$(b& AND 255): b& = b& \ 256
       NEXT
     NEXT
     u$ = Result$
     MID$(Font, i% * 48 + 1, 48) = u$
NEXT
READ t
t$ = CHR$(t)
MID$(Font, 2305, 1) = t$

'Save font to file
'OPEN "6x6.FNT" FOR BINARY AS 1
'PUT 1, , Font
'CLOSE 1

DIM SHARED face, shaddow, hilight, black, whitetext         'colors to use

face = DQBfindCol(47, 47, 47)                     'you can change these, if
shaddow = DQBfindCol(31, 31, 31)                 'you want different colors
hilight = DQBfindCol(63, 63, 63)
black = DQBfindCol(0, 0, 0)
whitetext = DQBfindCol(63, 63, 63)

a = DQBinit(0, 0)
IF a THEN PRINT "DQbInit error: "; a: END

DQBinitVGA

FOR i% = 0 TO 199
     DQBline 0, 0, i%, 319, i%, 16 + ((15 / 199) * i%)
NEXT

DQBsetFont Font

IF NOT DQBmouseDetected THEN
     a% = MsgBox("Even this demo requires a mouse!", "Press  Enter", "Mouse not found|0C", 1)
     DQBclose
     DQBinitText
     END
END IF

DQBmouseShow

a% = MsgBox("Message box for QuickBasic and DirectQB  by Jernej Simoni", "Next >>", "Message box demo", 1)
Nfo:
a% = MsgBox("Usage is simple:  btn% = MsgBox(text$,button$,title$,restbck%)  Please choose argument, you would like to  know more about:", "text$  button$  More>", "Message box demo: Usage", 1)
SELECT CASE a%
     CASE 3
          b% = MsgBox("Usage is simple:  btn% = MsgBox(text$,button$,title$,restbck%)  Please choose argument, you would like to  know more about:", "title$  restbck%  More<", "Message box demo: Usage", 1)
          SELECT CASE b%
               CASE 2
                    c% = MsgBox("MsgBox can restore background after exiting.  To restore it, simply set last argument  to non-zero value.", "Back <<  Next >>", "Message box demo: restbck%", 0)
               CASE 1
                    c% = MsgBox("MsgBox's title is set with 3rd argument.  It can be 50 chars long.  To select title background color, add  pipe (|) and color number in hex to title.  (Example: " + CHR$(34) + "Your text|0C" + CHR$(34) +  _
" - light red bg)", "Back <<  Next >>", "Message box demo: title$|0A", 1)
               CASE 3
                    GOTO Nfo
          END SELECT
          b% = 9
          IF c% = 1 OR c% = -2 THEN GOTO Nfo
     CASE 1
          b% = MsgBox("To specify what text to show, use first argument.  Separate lines with two spaces.", "Back <<  Next >>", "Message box demo: text$", 1)
     CASE 2
          b% = MsgBox("Buttons are set through 2nd argument.  MsgBox can have up to 3 buttons.  To separate buttons, use two spaces.", "Back <<  Next >>", "Message box demo: button$", 1)
END SELECT
IF b% = 1 OR b% = -2 THEN GOTO Nfo

Returns:
a% = MsgBox("MsgBox returns clicked button number.  Aditionally, if Enter or Esc was pressed,  it returns -1 or -2.  Note: custom keyboard handler must not be  installed, or keys won't be detected.  (MsgBox will still work with keyb. handler)",  _
"Back <<  Next >>", "Message box demo: Returns", 1)
IF a% = 1 OR a% = -2 THEN GOTO Nfo

Limits:
a% = MsgBox("MsgBox limitations:  maximum of 3 buttons allowed,  max. line lenght is 50 chars,  lines aren't automatically wrapped.", "Back <<  Next >>", "Message box demo: Limits", 1)
IF a% = 1 OR a% = -2 THEN GOTO Returns

MenuDemo:
a% = MsgBox("Do you want to see menu  demonstration?", "Yes  No  Back <<", "Menu demo", 1)
IF a% = 3 OR a% = -2 THEN GOTO Limits

IF a% = 1 THEN
     a% = MsgBox("After pressing OK, menu will apear.  Select one item.", "OK", "Menu demo", 1)
     a% = Menu(30, 30, "Open  Save  -  Exit", 0, 1)
     SELECT CASE a%
          CASE 1: t$ = "Open"
          CASE 2: t$ = "Save"
          CASE 4: t$ = "Exit"
     END SELECT
     a% = MsgBox("You have selected " + t$ + ".", "Next >>", "Menu demo", 1)
     a% = MsgBox("Try clicking outside of menu.", "OK", "Menu demo", 1)
     a% = Menu(20, 20, "This menu can't  be closed with  clicking  outside of it.", 0, 1)
MenuOut:
     a% = Menu(40, 40, "Try draging mouse  outside of me.  Then click outside  of me!", 1, 1)
     IF a% <> -1 THEN a% = MsgBox("Click outside of menu.", "Retry", "Menu demo", 1): GOTO MenuOut
MenuUsg:
     a% = MsgBox("Menu usage:  item% = Menu(x%, y%, items$, clkout%, restbk%)  Choose paramenter, you would like  to know more about.", "x%, y%  items$  More>", "Menu demo: usage", 1)
     SELECT CASE a%
          CASE 1
               c% = MsgBox("Set position of menu with first  two paramenters.", "Back <<  Next >>", "Menu demo: x%, y%", 1)
          CASE 2
               c% = MsgBox("Menu items are set through second  paramenter. Separate them with two  spaces.  To draw separator, use - .", "Back <<  Next >>", "Menu demo: items$", 1)
          CASE 3
               b% = MsgBox("Menu usage:  item% = Menu(x%, y%, items$, clkout%, restbk%)  Choose paramenter, you would like  to know more about.", "clkout%  restbk%  More<", "Menu demo: usage", 1)
               SELECT CASE b%
                    CASE 1
                         c% = MsgBox("User may click outside of menu.  Menu can ignore this, or it can close.  Set third paramenter to non-zero, to  detect clicks outside of menu.  Note: if user drags mouse out of menu,  it isn't closed.",  _
"Back <<  Next >>", "Menu demo: clkout%", 1)
                    CASE 2
                         c% = MsgBox("Just as MsgBox, Menu can restore background  after closing.  Set last paramenter to non-zero  value to do it.", "Back <<  Next >>", "Menu demo: restbk%", 1)
                    CASE 3
                         GOTO MenuUsg
               END SELECT
     END SELECT
     IF c% = 1 THEN GOTO MenuUsg
     a% = MsgBox("Menu returns value, which indicates  selected item.", "Back <<  Next >>", "Menu demo: returns", 1)
     IF a% = 1 THEN GOTO MenuUsg
END IF

InputDemo:
a% = MsgBox("Do you want to see input box demo?  (Only demo, no usage info, I don't  have time to do it.)", "Yes  No  Back <<", "InputBox demo", 1)
IF a% = 3 THEN GOTO MenuDemo

IF ABS(a%) = 1 THEN
     a$ = "Your text"
Again:
     InputBox a$, "Type some text.  (InputBox doesn't work with  custom keyboard handler)", "OK  Not OK", "InputBox demo", btn%, 1
     a% = MsgBox("You have typed:  " + a$ + "  and pressed button " + STR$(btn%), "Again <<  Next >>", "InputBox demo: Returned", 1)
     IF a% = 1 THEN GOTO Again
END IF

Fontt:
a% = MsgBox("Font used by MsgBox, InputBox, Menu and  Button is fixed 6x6 size font.  It is stored in this program.  To save it to FNT file, find comment  'Save font to file  and uncomment following 3 lines.", "Back <<  Next>>", "Font info", 1)
IF a% = 1 OR a% = -2 THEN GOTO InputDemo

a% = MsgBox("You can use MsgBox, Button and Menu  freely in your programs,  just give me a credit.    Jernej Simoni, jernej.simoncic@guest.arnes.si", "Back <<  Finnish", "Message box, Menu and Button are freeware", 1)
IF a% = 1 OR a% = -2 THEN GOTO Fontt:

DQBmouseHide
DQBinitText

DQBclose


Font:
DATA "6mVKdY10000N4b<QdR700P7odb?ch100@Q?n`1200008`Q?LP000002LXR?Z`100"
DATA "P07nh32L0000003<00000`?o<c<ol300003B8130000o<C;]<c?00`13d19TP100"
DATA "`Q8LP078000>8Q7@03<00`7AlA4c<300X27f`Q:0000PPS?h02000P0>hS320000"
DATA "P078`120000D@150@1000P7ZXQ2:0000h04<`P0L00000000hS?0002LP078h300"
DATA "P07ZP0200008PP:LP0000024h3180000P04n01200000008n0000000Dh3500000"
DATA "P02L`Q?0000n`178P000000000000000P0280020000D@1000000005n@Q?D0000"
DATA "PP7lX0?8000R@02@8200004X01:D0000014000000004P028@0000024@0180000"
DATA "PP:LX2200008PP?8P0000000004@0200000n00000000000002000P04P04P0000"
DATA "`Q8Z82700008P1:8`10000?2`18n0000`S0<80?0000<@19n@0000P?P`S0l0000"
DATA "`18l8270000n8018P000007R`Q8L0000`Q8N80700000P0080000000@004@0200"
DATA "@02@P0100000h10N00000048@02@0000`Q0<0020000L8R;P`100007R8R?R0000"
DATA "`S4L81?0000N828Rh10000?B8Q4l0000h34L0Q?0000n017@P3000P7PHR8N0000"
DATA "H35L@Q=0000nP028h3000P34@09H0000835H@Q<0000h014Bh3000P8fXR8R0000"
DATA "8R<ZHR80000L8R8R`10000?B`14h0000`Q8R@R60000l817BX3000P7P`Q0l0000"
DATA "hS:8P070000R8R8R`1000P8R@15800008R8ZX250000R@12D82000P8DP0280000"
DATA "h3988Q?0000<P028`000008@P0120000`014@0300008@100000000000000l300"
DATA "012000000000hP4Bh000004L8Q4L00000P3@0Q300002hP4Bh000000<h14<0000"
DATA "@02LP0200000hP4>8030004@`Q4B0000P008P02000040034@020004DP15B0000"
DATA "P028P0100000@S:R8200000L8Q4B0000003B81300000`Q4B`140000>8Q4>8000"
DATA "0P5H01400000h072`100002LP02400000P4B8Q3000008R8DP000000R8R:D0000"
DATA "0P4<`P4000008Q4>8030000N@02N0000`02@P0300008P008P0000068@02H0000"
DATA "X05000000000P05L000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "00000000000000000000000000000000XP3@0Q30000000000000000000000000"
DATA "00000000000000000000000000000000`P74PP70000Dh33@h300000000000000"
DATA "0000000000000000000000000000000000000000000Bh18Ph100000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "000000000000000000000P2N`S0l0000XP3L8070000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "00000000000000000000000000000000815B@20000P16HP16HP16HP16HP16HP1"
DATA "6HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP1"
DATA "6HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP1"
DATA "6HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP1"
DATA "6HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP1"
DATA "6HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP16HP1"
DATA  6

REM $DYNAMIC
'
' Button - draw button at given location
'
' Usage:  Button layer%, x%, y%, text$, press%
'
'    layer%    layer to draw button on
'    x%, y%    button position
'    text$     text to show (font size should be 6x6; 8 chars limit)
'    press%    bevel inset/raised
'
'=============================================================================
'
' Notes: -mouse cursor isn't hidden when drawing button
'        -used by MsgBox
'
' Requires: DirectQB
'
' Button by Jernej Simnocic, DirectQB by Angelo Motolla
'
SUB Button (lay%, bx%, by%, bwidth%, bheight%, txt$, press%)

     away% = 2

     IF bwidth% = 0 THEN bwidth% = 52
     IF bheight% = 0 THEN bheight% = 10: away% = 3

     DQBboxf lay%, bx%, by%, bx% + bwidth%, by% + bheight%, face
     DQBbox lay%, bx%, by%, bx% + bwidth%, by% + bheight%, hilight

     SELECT CASE press%
          CASE 0
               DQBline lay%, bx%, by% + bheight%, bx% + bwidth%, by% + bheight%, shaddow
               DQBline lay%, bx% + bwidth%, by%, bx% + bwidth%, by% + bheight%, shaddow
               DQBprint lay%, txt$, bx% + bwidth% \ 2 - LEN(txt$) * 3, by% + away%, black
          CASE ELSE
               DQBline lay%, bx%, by%, bx% + bwidth%, by%, shaddow
               DQBline lay%, bx%, by%, bx%, by% + bheight%, shaddow
               DQBprint lay%, txt$, bx% + bwidth% \ 2 + 1 - LEN(txt$) * 3, by% + 1 + away%, black
     END SELECT

END SUB

REM $STATIC
'
' InputBox - message box with text input field
'
' Usage: InputBox inputtext$, showtext$, buttons$, title$, pbutton%, restbck%
'
'    inputtext$     Returns text typed into input box. Can be used to set
'                   default text.
'    showtext$      Text to show in input box. (like text$ in MsgBox)
'    buttons$       Buttons to show.
'    title$         InputBox title text. Can include title color: add | and
'                   color in hex (example: "Title text|03" - cyan background)
'    pbutton%       Contains pressed button number at exit. (Enter:-1, Esc:-2)
'    restbck%       Restore background at exit.
'
'=============================================================================
'
' Notes: lenght of text to return isn't limited. Size of input field depends
'        on longest line lenght and title. If text is too long to fit in input
'        field, only last chars will be shown.
'
' Requires: DirectQB, SUB Button
'
' InputBox by Jernej Simoncic, DirectQB by Angelo Motolla
'
SUB InputBox (inptext$, txt$, btn$, tit$, pbutton%, resbk%)

maxlines% = 6                                'maximum number of lines - change
                                             'if you need more
maxlines% = maxlines% - 1

titleclr% = 9                                'default title color

WHILE INKEY$ <> "": WEND                     'clear keyboard buffer

IF LEN(tit$) > 2 THEN
     IF MID$(tit$, LEN(tit$) - 2, 1) = "|" THEN   'extract title color from title
          titleclr% = VAL("&h" + RIGHT$(tit$, 2)) 'text, if given
          tit$ = LEFT$(tit$, LEN(tit$) - 3)
     END IF
END IF

DQBwait 1                                    'no flicker
DQBgetCol titleclr%, r%, g%, b%              'find title text color
IF (.3 * r% + .59 * g% + .11 * b%) > 31 THEN titletxtclr% = DQBfindCol(0, 0, 0) ELSE titletxtclr% = DQBfindCol(63, 63, 63)

txxt$ = txt$                                 'do not change text argument

DIM Lines(maxlines%) AS STRING               'array to hold text lines

numlines% = maxlines% + 1                    'default number of lines

FOR i% = 0 TO maxlines%                      'parse text
     l% = INSTR(txxt$, "  ")
     IF l% > 0 THEN
          Lines(i%) = LEFT$(txxt$, l% - 1)
          txxt$ = RIGHT$(txxt$, LEN(txxt$) - (l% + 1))
     ELSE
          Lines(i%) = txxt$
          txxt$ = ""
     END IF
     IF LEN(Lines(i%)) > 50 THEN Lines(i%) = LEFT$(Lines(i%), 50) 'too long lines cause problems
     IF LEN(Lines(i%)) > maxlen% THEN maxlen% = LEN(Lines(i%))   'find longest line lenght
     IF LEN(txxt$) = 0 THEN                  'we have parsed whole text
          numlines% = i% + 3                 'number of lines (+2 for text
          EXIT FOR                           'field)
     END IF
NEXT

btt$ = btn$                                  'same as text

DIM Buttons(2) AS STRING

FOR i% = 0 TO 2                              'parse buttons
     l% = INSTR(btt$, "  ")
     IF l% > 0 THEN
          Buttons(i%) = LEFT$(btt$, l% - 1)
          btt$ = RIGHT$(btt$, LEN(btt$) - (l% + 1))
     ELSE
          Buttons(i%) = btt$
          btt$ = ""
     END IF
     IF LEN(Buttons(i%)) > 8 THEN Buttons(i%) = LEFT$(Buttons(i%), 8)
     IF LEN(btt$) = 0 THEN numbuttons% = i% + 1: EXIT FOR
NEXT

IF LEN(tit$) > maxlen% THEN maxlen% = LEN(tit$)   'adjust maxlen%
IF numbuttons% = 1 AND maxlen% < 7 THEN maxlen% = 7
IF numbuttons% = 2 AND maxlen% < 16 THEN maxlen% = 16
IF numbuttons% = 3 AND maxlen% < 25 THEN maxlen% = 25

DQBwait 1
DQBmouseHide                                 'hide mouse when drawing

IF resbk% THEN                               'do we want to restore background
                                             'calc size
     Size% = DQBsize(150 - maxlen% * 3, 89 - numlines% * 3, 170 + maxlen% * 3, 112 + numlines% * 3)
     DIM Back%(Size% \ 2)
                                             'get background
     DQBget 0, 150 - maxlen% * 3, 89 - numlines% * 3, 170 + maxlen% * 3, 112 + numlines% * 3, VARSEG(Back%(0)), VARPTR(Back%(0))
END IF

                                             'draw window
Button 0, 150 - maxlen% * 3, 89 - numlines% * 3, 20 + maxlen% * 6, 23 + numlines% * 6, "", 0
DQBboxf 0, 151 - maxlen% * 3, 90 - numlines% * 3, 169 + maxlen% * 3, 97 - numlines% * 3, titleclr%

                                             'draw input field
DQBboxf 0, 153 - maxlen% * 3, 95 + (numlines% - 2) * 3, 167 + maxlen% * 3, 98 + numlines% * 3, black
DQBbox 0, 153 - maxlen% * 3, 95 + (numlines% - 2) * 3, 167 + maxlen% * 3, 98 + numlines% * 3, shaddow
DQBline 0, 153 - maxlen% * 3, 98 + numlines% * 3, 167 + maxlen% * 3, 98 + numlines% * 3, hilight
DQBline 0, 167 + maxlen% * 3, 95 + (numlines% - 2) * 3, 167 + maxlen% * 3, 98 + numlines% * 3, hilight

                                             'print title
DQBprint 0, tit$, 160 - LEN(tit$) * 3, 91 - numlines% * 3, titletxtclr%

                                             'print default text
DQBprint 0, inptext$, 155 - maxlen% * 3, 97 + (numlines% - 2) * 3, cyan

FOR i% = 0 TO numlines% - 1                  'print message
     DQBprint 0, Lines(i%), 160 - LEN(Lines(i%)) * 3, 99 - numlines% * 3 + i% * 6, black
NEXT

DIM ButtonDown(2) AS INTEGER                 'which button is pressed

DQBmouseShow                                 'show mouse

FirstTime% = -1                              'needed for button drawing
DO

     IF DQBmouseLB = 0 AND FirstTime% = 0 THEN    'check for pressed button
          FOR i% = 0 TO 2
               IF ButtonDown(i%) = -1 THEN found% = i% + 1  'one is pressed
          NEXT
          IF found% <> 0 THEN
               pbutton% = found%
               EXIT DO
          END IF
     END IF
    
     DO
          in$ = INKEY$
          IF in$ <> "" THEN
               SELECT CASE in$
                    CASE CHR$(27)
                         pbutton% = -2: EXIT DO  'exit if Esc is pressed
                    CASE CHR$(13)
                         pbutton% = -1: EXIT DO  '  "     Enter    "
                    CASE CHR$(8)
                         IF LEN(inptext$) > 0 THEN
                              inptext$ = LEFT$(inptext$, LEN(inptext$) - 1)
                         END IF
                         in$ = ""
                    CASE ELSE
                         inptext$ = inptext$ + in$
                         in$ = ""
               END SELECT

               IF LEN(inptext$) > maxlen% + 2 THEN
                    shwt$ = RIGHT$(inptext$, maxlen% + 2)
               ELSE
                    shwt$ = inptext$
               END IF

               DQBwait 1
               DQBmouseHide
               DQBboxf 0, 154 - maxlen% * 3, 96 + (numlines% - 2) * 3, 166 + maxlen% * 3, 97 + numlines% * 3, black
               DQBprint 0, shwt$, 155 - maxlen% * 3, 97 + (numlines% - 2) * 3, cyan
               DQBmouseShow
          END IF
     LOOP UNTIL DQBmouseLB OR FirstTime%

     IF in$ <> "" THEN EXIT DO                    'if key was pressed, exit

     mx% = DQBmouseX
     my% = DQBmouseY

     FOR i% = 0 TO 2                              'reset button values
          ButtonDown(i%) = 0
     NEXT
                                               'find, if any button is pressed
     IF my% >= 100 + numlines% * 3 AND my% <= 110 + numlines% * 3 AND NOT FirstTime% THEN
          IF numbuttons% = 1 THEN
               SELECT CASE mx%
                    CASE 134 TO 186: ButtonDown(0) = -1
               END SELECT
          ELSEIF numbuttons% = 2 THEN
               SELECT CASE mx%
                    CASE 107 TO 159: ButtonDown(0) = -1
                    CASE 161 TO 213: ButtonDown(1) = -1
               END SELECT
          ELSE
               SELECT CASE mx%
                    CASE 80 TO 132: ButtonDown(0) = -1
                    CASE 134 TO 186: ButtonDown(1) = -1
                    CASE 188 TO 240: ButtonDown(2) = -1
               END SELECT
          END IF
     END IF

     DQBwait 1                     'with this, mouse pointer shouldn't flicker

     DQBmouseHide                              'hide mouse cursor when drawing

     SELECT CASE numbuttons%                      'draw buttons
          CASE 1
               Button 0, 134, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
          CASE 2
               Button 0, 107, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
               Button 0, 161, 100 + numlines% * 3, 0, 0, Buttons(1), ButtonDown(1)
          CASE 3
               Button 0, 80, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
               Button 0, 134, 100 + numlines% * 3, 0, 0, Buttons(1), ButtonDown(1)
               Button 0, 188, 100 + numlines% * 3, 0, 0, Buttons(2), ButtonDown(2)
     END SELECT

     DQBmouseShow                                 'show cursor

     FirstTime% = 0

LOOP

IF resbk% THEN                                    'restore background image

     DQBmouseHide

     DQBfPut 0, 150 - maxlen% * 3, 89 - numlines% * 3, VARSEG(Back%(0)), VARPTR(Back%(0))

     DQBmouseShow

END IF

ERASE Back%, Lines, Buttons, ButtonDown

END SUB

REM $DYNAMIC
'
' Menu - draws a menu and returns selected item
'
' Usage: item% = Menu(x%, y%, Items$, clickoutside%, restbck%)
'
'  item%            returns selected item number (-1 if clicked outside)
'  x%, y%           position of menu
'  Items$           menu items. Separate with two spaces. Use - for line
'  clickoutside%    close menu if clicked outside borders
'  restbck%         restore background after closing
'
'=============================================================================
'
' Note: no checks are done
'
' Requires: DirectQB
'
' Menu by Jernej Simoni, DirectQB by Angelo Mottola
'
FUNCTION Menu (x%, y%, Items AS STRING, clickouts%, restbck%)

maxitems% = 30                'maximum number of items - should be fine

txxt$ = Items

DIM Items(maxitems%) AS STRING

FOR i% = 0 TO maxitems%       'parse items
     l% = INSTR(txxt$, "  ")
     IF l% > 0 THEN
          Items(i%) = LEFT$(txxt$, l% - 1)
          txxt$ = RIGHT$(txxt$, LEN(txxt$) - (l% + 1))
     ELSE
          Items(i%) = txxt$
          txxt$ = ""
     END IF
     IF LEN(Items(i%)) > 50 THEN Items(i%) = LEFT$(Items(i%), 20) 'too long items cause problems
     IF LEN(Items(i%)) > maxlen% THEN maxlen% = LEN(Items(i%))   'find longest item lenght
     IF LEN(txxt$) = 0 THEN                  'we have parsed whole text
          numitems% = i% + 1                 'number of items
          EXIT FOR
     END IF
NEXT

DQBwait 1
DQBmouseHide                  'hide mouse cursor when drawing

IF restbck% <> 0 THEN         'get background image
     Size% = DQBsize(x%, y%, x% + maxlen% * 6 + 6, y% + numitems% * 6 + 6)
     DIM Back%(Size% \ 2)

     DQBget 0, x%, y%, x% + maxlen% * 6 + 6, y% + numitems% * 6 + 6, VARSEG(Back%(0)), VARPTR(Back%(0))
END IF

                              'draw menu
Button 0, x%, y%, maxlen% * 6 + 6, numitems% * 6 + 6, "", 0

FOR i% = 0 TO numitems% - 1   'print items
     IF Items(i%) <> "-" THEN
          DQBprint 0, Items(i%), x% + 3, y% + i% * 6 + 3, black
     ELSE
          DQBline 0, x% + 3, y% + i% * 6 + 5, x% + maxlen% * 6 + 3, y% + i% * 6 + 5, shaddow
          DQBline 0, x% + 3, y% + i% * 6 + 6, x% + maxlen% * 6 + 3, y% + i% * 6 + 6, hilight
     END IF
NEXT

DQBmouseShow

DO

     DO
          IF NOT DQBmouseLB AND sel% > 0 AND sel% <= numitems% THEN    'did we
               Menu = sel%                                  'select something
               GOTO MenuEnd
          END IF
          IF NOT DQBmouseLB THEN noout% = 0  'needed for outside of menu click
     LOOP UNTIL DQBmouseLB                   'detection

     mx% = DQBmouseX
     my% = DQBmouseY

     DQBwait 1
     DQBmouseHide             'hide mouse cursor

                              're-draw menu
     DQBboxf 0, x% + 1, y% + 1, x% + maxlen% * 6 + 5, y% + numitems% * 6 + 5, face
     FOR i% = 0 TO numitems% - 1
          IF Items(i%) <> "-" THEN
               DQBprint 0, Items(i%), x% + 3, y% + i% * 6 + 3, black
          ELSE
               DQBline 0, x% + 3, y% + i% * 6 + 5, x% + maxlen% * 6 + 3, y% + i% * 6 + 5, shaddow
               DQBline 0, x% + 3, y% + i% * 6 + 6, x% + maxlen% * 6 + 3, y% + i% * 6 + 6, hilight
          END IF
     NEXT
    
     sel% = 0
                              'is any item selected
     IF mx% > x% + 3 AND mx% < x% + maxlen% * 6 + 3 THEN
          sel% = (my% - y% - 3) \ 6
          IF sel% < numitems% AND sel% >= 0 THEN  'yes
               IF Items(sel%) <> "-" THEN         'we can't select separator
                    DQBboxf 0, x% + 3, y% + sel% * 6 + 2, x% + maxlen% * 6 + 3, y% + sel% * 6 + 8, black
                    DQBprint 0, Items(sel%), x% + 3, y% + sel * 6 + 3, cyan
                    sel% = sel% + 1
                    noout% = -1    'this variable tells, if mouse was draged
               ELSE                'out of menu, or if not
                    sel% = 0
               END IF
          ELSE                'no, did we click outside of menu
               IF clickouts% AND (my% < y% OR my% > y% + numitems% * 6 + 6) AND NOT noout% THEN
                    Menu = -1      '(if mouse was accidently draged out of
                    GOTO MenuEnd   'menu, menu won't be closed)
               END IF
          END IF
     ELSE                     'same as above
          IF clickouts% AND NOT noout% THEN
               Menu = -1
               GOTO MenuEnd
          END IF
     END IF

     DQBmouseShow

LOOP

MenuEnd:
IF restbck% <> 0 THEN    'restore background
     DQBmouseHide
     DQBfPut 0, x%, y%, VARSEG(Back%(0)), VARPTR(Back%(0))
     DQBmouseShow
END IF

ERASE Back%, Items

END FUNCTION

'
' MsgBox - draws a message box
'
' Usage:  ret% = MsgBox(text$, button$, title$, restbck%)
'
'    ret%      pressed button (1,2,3; -1: Enter; -2: Esc)
'    text$     text to show. Separate lines with two spaces
'    button$   buttons to show. Separate with two spaces
'    title$    MsgBox title text. Can include title color: add | and color in
'              hex (example: "Title text|0C" - bright red background)
'    restbck%  restore background after closing
'
'=============================================================================
'
' Important! Font size must be 6x6, or MsgBox will look horrible.
'
' Limitations:  6 lines of text (for more, change maxlines% var)
'               3 buttons
'               no line wrapping
'
' Requires:  DirectQB, SUB Button
'
' MsgBox by Jernej Simoncic; DirectQB by Angelo Motolla
'
FUNCTION MsgBox (txt$, btn$, tit$, resbk%)

maxlines% = 6                                'maximum number of lines - change
                                             'if you need more
maxlines% = maxlines% - 1

titleclr% = 9                                'default title color

WHILE INKEY$ <> "": WEND                     'clear keyboard buffer

IF LEN(tit$) > 2 THEN
     IF MID$(tit$, LEN(tit$) - 2, 1) = "|" THEN   'extract title color from title
          titleclr% = VAL("&h" + RIGHT$(tit$, 2)) 'text, if given
          tit$ = LEFT$(tit$, LEN(tit$) - 3)
     END IF
END IF

DQBwait 1                                    'no flicker
DQBgetCol titleclr%, r%, g%, b%              'find title text color
IF (.3 * r% + .59 * g% + .11 * b%) > 31 THEN titletxtclr% = DQBfindCol(0, 0, 0) ELSE titletxtclr% = DQBfindCol(63, 63, 63)

txxt$ = txt$                                 'do not change text argument

DIM Lines(maxlines%) AS STRING               'array to hold text lines

numlines% = maxlines% + 1                    'default number of lines

FOR i% = 0 TO maxlines%                      'parse text
     l% = INSTR(txxt$, "  ")
     IF l% > 0 THEN
          Lines(i%) = LEFT$(txxt$, l% - 1)
          txxt$ = RIGHT$(txxt$, LEN(txxt$) - (l% + 1))
     ELSE
          Lines(i%) = txxt$
          txxt$ = ""
     END IF
     IF LEN(Lines(i%)) > 50 THEN Lines(i%) = LEFT$(Lines(i%), 50) 'too long lines cause problems
     IF LEN(Lines(i%)) > maxlen% THEN maxlen% = LEN(Lines(i%))   'find longest line lenght
     IF LEN(txxt$) = 0 THEN                  'we have parsed whole text
          numlines% = i% + 1                 'number of lines
          EXIT FOR
     END IF
NEXT

btt$ = btn$                                  'same as text

DIM Buttons(2) AS STRING

FOR i% = 0 TO 2                              'parse buttons
     l% = INSTR(btt$, "  ")
     IF l% > 0 THEN
          Buttons(i%) = LEFT$(btt$, l% - 1)
          btt$ = RIGHT$(btt$, LEN(btt$) - (l% + 1))
     ELSE
          Buttons(i%) = btt$
          btt$ = ""
     END IF
     IF LEN(Buttons(i%)) > 8 THEN Buttons(i%) = LEFT$(Buttons(i%), 8)
     IF LEN(btt$) = 0 THEN numbuttons% = i% + 1: EXIT FOR
NEXT

IF LEN(tit$) > maxlen% THEN maxlen% = LEN(tit$)   'adjust maxlen%
IF numbuttons% = 1 AND maxlen% < 7 THEN maxlen% = 7
IF numbuttons% = 2 AND maxlen% < 16 THEN maxlen% = 16
IF numbuttons% = 3 AND maxlen% < 25 THEN maxlen% = 25

DQBwait 1
DQBmouseHide                                 'hide mouse when drawing

IF resbk% THEN                               'do we want to restore background
                                             'calc size
     Size% = DQBsize(150 - maxlen% * 3, 89 - numlines% * 3, 170 + maxlen% * 3, 112 + numlines% * 3)
     DIM Back%(Size% \ 2)
                                             'get background
     DQBget 0, 150 - maxlen% * 3, 89 - numlines% * 3, 170 + maxlen% * 3, 112 + numlines% * 3, VARSEG(Back%(0)), VARPTR(Back%(0))
END IF

                                             'draw window
Button 0, 150 - maxlen% * 3, 89 - numlines% * 3, 20 + maxlen% * 6, 23 + numlines% * 6, "", 0
DQBboxf 0, 151 - maxlen% * 3, 90 - numlines% * 3, 169 + maxlen% * 3, 97 - numlines% * 3, titleclr%

                                             'print title
DQBprint 0, tit$, 160 - LEN(tit$) * 3, 91 - numlines% * 3, titletxtclr%

FOR i% = 0 TO numlines% - 1                  'print message
     DQBprint 0, Lines(i%), 160 - LEN(Lines(i%)) * 3, 99 - numlines% * 3 + i% * 6, black
NEXT

DIM ButtonDown(2) AS INTEGER                 'which button is pressed

DQBmouseShow                                 'show mouse

FirstTime% = -1                              'needed for button drawing
DO

     IF DQBmouseLB = 0 AND FirstTime% = 0 THEN    'check for pressed button
          FOR i% = 0 TO 2
               IF ButtonDown(i%) = -1 THEN found% = i% + 1  'one is pressed
          NEXT
          IF found% <> 0 THEN
               MsgBox = found%
               EXIT DO
          END IF
     END IF
      
     DO
          in$ = INKEY$
          IF in$ = CHR$(27) THEN MsgBox = -2: EXIT DO  'exit if Esc is pressed
          IF in$ = CHR$(13) THEN MsgBox = -1: EXIT DO  '  "     Enter    "
     LOOP UNTIL DQBmouseLB OR FirstTime%

     IF in$ <> "" THEN EXIT DO                    'if key was pressed, exit
 
     mx% = DQBmouseX
     my% = DQBmouseY

     FOR i% = 0 TO 2                              'reset button values
          ButtonDown(i%) = 0
     NEXT
                                               'find, if any button is pressed
     IF my% >= 100 + numlines% * 3 AND my% <= 110 + numlines% * 3 AND NOT FirstTime% THEN
          IF numbuttons% = 1 THEN
               SELECT CASE mx%
                    CASE 134 TO 186: ButtonDown(0) = -1
               END SELECT
          ELSEIF numbuttons% = 2 THEN
               SELECT CASE mx%
                    CASE 107 TO 159: ButtonDown(0) = -1
                    CASE 161 TO 213: ButtonDown(1) = -1
               END SELECT
          ELSE
               SELECT CASE mx%
                    CASE 80 TO 132: ButtonDown(0) = -1
                    CASE 134 TO 186: ButtonDown(1) = -1
                    CASE 188 TO 240: ButtonDown(2) = -1
               END SELECT
          END IF
     END IF

     DQBwait 1                     'with this, mouse pointer shouldn't flicker

     DQBmouseHide                              'hide mouse cursor when drawing

     SELECT CASE numbuttons%                      'draw buttons
          CASE 1
               Button 0, 134, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
          CASE 2
               Button 0, 107, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
               Button 0, 161, 100 + numlines% * 3, 0, 0, Buttons(1), ButtonDown(1)
          CASE 3
               Button 0, 80, 100 + numlines% * 3, 0, 0, Buttons(0), ButtonDown(0)
               Button 0, 134, 100 + numlines% * 3, 0, 0, Buttons(1), ButtonDown(1)
               Button 0, 188, 100 + numlines% * 3, 0, 0, Buttons(2), ButtonDown(2)
     END SELECT

     DQBmouseShow                                 'show cursor

     FirstTime% = 0

LOOP

IF resbk% THEN                                    'restore background image

     DQBmouseHide

     DQBfPut 0, 150 - maxlen% * 3, 89 - numlines% * 3, VARSEG(Back%(0)), VARPTR(Back%(0))

     DQBmouseShow

END IF

ERASE Back%, Lines, Buttons, ButtonDown

END FUNCTION

